import java.io.*;
import java.net.*;

class ServerThread extends Thread {
  private Socket socket;
  private BufferedReader in;
  private PrintWriter out;
  private String name;
  private int waitResults = 0;
  private int[] cLunes = {0,0,0,0,0,0,0};
  private int[] cMartes = {0,0,0,0,0,0,0};
  private int[] cMiercoles = {0,0,0,0,0,0,0};
  private int[] cJueves = {0,0,0,0,0,0,0};
  private int[] cViernes = {0,0,0,0,0,0,0};

  public ServerThread(Socket s) throws IOException {
    //System.out.println("Begin new Thread!");
    socket = s;
    in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
    start();
  }

  public void WriteToClient(String str){
    out.println(str);
  }
  
  public String ListenToClient() {
    try {
      return in.readLine();
    } catch(IOException e){
      System.out.println("Error desconectar cliente");
    }
    return "";
  }

  public void run() {
    //System.out.println("enter while true in Thread!");
    while (true) {
      AskScheduleClient();
      WriteSchedule(-1,-1,-1,-1);
      while(waitResults==0){};
    }
  }

  private void AskScheduleClient(){
    String nombreAyudantia = ServerCore.ayudaClase;
    WriteToClient("Bienvenido al servicio de coordinacion de la ayduantia de " +nombreAyudantia);
    WriteToClient("Ingrese su Nombre: ");
    name = ListenToClient();
    WriteToClient("Ingrese una cadena de 1s y 0s indicando con 1 los bloques ocupados");
    WriteToClient("por ejemplo, si ingresa: ");
    WriteToClient("1 2 3 4 5 6 7");
    WriteToClient("1 1 1 0 0 0 0");
    WriteToClient("Corresponde a un dia en que tiene ocupado bloques del 1 al 6");

    WriteToClient("Lunes:");
    String lunesStr = ListenToClient();
    cLunes = ServerCore.StringToArray(lunesStr);

    WriteToClient("Martes:");
    String martesStr = ListenToClient();
    cMartes = ServerCore.StringToArray(martesStr);

    WriteToClient("Miercoles:");
    String miercolesStr = ListenToClient();
    cMiercoles = ServerCore.StringToArray(miercolesStr);

    WriteToClient("Jueves:");
    String juevesStr = ListenToClient();
    cJueves = ServerCore.StringToArray(juevesStr);

    WriteToClient("Viernes:");
    String viernesStr = ListenToClient();
    cViernes = ServerCore.StringToArray(viernesStr);

    WriteToClient("Su horario ha sido ingresado correctamente!");
    WriteToClient("No se desconecte, espere los resultados");

    AddSchedule(ServerCore.lunes,ServerCore.martes,ServerCore.miercoles,ServerCore.jueves,ServerCore.viernes);
    ServerCore.contadorRespuestas++;
    System.out.println(ServerCore.contadorAlumnos+" de "+ServerCore.MAXCLIENTS +" han ingresado su horario");
    
    //System.out.println(ServerCore.contadorRespuestas +"  respuestas "+ ServerCore.MAXCLIENTS);
  }

  public void AddSchedule(int[] lu, int[] ma, int[] mi,int[] ju, int[] vi){
    ServerCore.CountDay(lu, cLunes);
    ServerCore.CountDay(ma, cMartes);
    ServerCore.CountDay(mi, cMiercoles);
    ServerCore.CountDay(ju, cJueves);
    ServerCore.CountDay(vi, cViernes);

    //ServerCore.PrintSchedule(cLunes,cMartes,cMiercoles,cJueves,cViernes);
  }

  public int CheckIfCanAssit(int day, int blocks, int printBool){
    if(printBool==1){
     PrintFixedSchedule(day,blocks);
    }
    if (blocks>=7){
      if(printBool==1){
        System.out.println("Este horario no existe!");
      }
      return 0;
    }
    switch (day) {
      case 0:{
        if(cLunes[blocks]==0){
          if(printBool==1){
            WriteToClient("Usted no posee tope!");
          }
          return 1;
        }
        break;
      }
      case 1:{
        if(cMartes[blocks]==0){
          if(printBool==1){
            WriteToClient("Usted no posee tope!");
          }
          return 1;
        }
        break;
      }
      case 2:{
        if(cMiercoles[blocks]==0){
          if(printBool==1){
            WriteToClient("Usted no posee tope!");
          }
          return 1;
        }
        break;
      }
      case 3:{
        if(cJueves[blocks]==0){
          if(printBool==1){
            WriteToClient("Usted no posee tope!");
          }
          return 1;
        }
        break;
      }
      case 4:{
        if(cViernes[blocks]==0){
          if(printBool==1){
            WriteToClient("Usted no posee tope!");
          }
          return 1;
        }
        break;
      }
    }
    if(printBool==1){
      WriteToClient("Este horario te hace tope!");
      System.out.println("Alumno con tope: "+name);
    }
    return 0;
  }

  private void PrintFixedSchedule(int dia, int bloque){
    String diaS = "dia";
    String bloqueS = "bloque";
    switch(dia){
      case 0:{
        diaS = "Lunes";
        break;
      }
      case 1:{
        diaS = "Martes";
        break;
      }
      case 2:{
        diaS = "Miercoles";
        break;
      }
      case 3:{
        diaS = "Jueves";
        break;
      }
      case 4:{
        diaS = "Viernes";
        break;
      }
    }
    int bloque1Real = 1+2*bloque;
    int bloque2Real = bloque1Real+1;
    bloqueS = bloque1Real+"-"+bloque2Real;
    WriteToClient("Se ha fijado el horario: "+diaS+" "+bloqueS);
  }

  public void WriteSchedule(int diaF1, int bloqueF1, int diaF2, int bloqueF2){
    int bloqueP1 = 1;
    int bloqueP2 = 2;
    String superString = "";
    WriteToClient("Bloque |lu| ma| mi| ju| vi|");

    for (int j=0;j<7 ;j++) {
      superString = "";
      if(bloqueP2<9){
        superString += bloqueP1 +" - "+bloqueP2+"  |";
      }else{
        if (bloqueP2==10){
          superString += bloqueP1 +" - "+bloqueP2+" |";
        }else{
          superString += bloqueP1 +" - "+bloqueP2+"|";
        }
      }
      char blocked='x';
      
      if ((diaF1==0 && bloqueF1==j)||(diaF2==0 && bloqueF2==j)){
        if(cLunes[j]==0){
          superString +=" "+blocked;
        }else{
          superString +=" "+cLunes[j];
        }
      }else{
        superString +=" "+cLunes[j];
      }
      superString +="| ";
      if ((diaF1==1 && bloqueF1==j)||(diaF2==1 && bloqueF2==j)){
        if(cMartes[j]==0){
          superString +=" "+blocked;
        }else{
          superString +=" "+cMartes[j];
        }
      }else{
        superString +=" "+cMartes[j];
      }
      superString +="| ";
      if ((diaF1==2 && bloqueF1==j)||(diaF2==2 && bloqueF2==j)){
        if(cMiercoles[j]==0){
          superString +=" "+blocked;
        }else{
          superString +=" "+cMiercoles[j];
        }
      }else{
        superString +=" "+cMiercoles[j];
      }
      superString +="| ";
      if ((diaF1==3 && bloqueF1==j)||(diaF2==3 && bloqueF2==j)){
        if(cJueves[j]==0){
          superString +=" "+blocked;  
        }else{
          superString +=" "+cJueves[j];
        }
      }else{
        superString +=" "+cJueves[j];
      }
      superString +="| ";
      if ((diaF1==4 && bloqueF1==j)||(diaF2==4 && bloqueF2==j)){
        if(cViernes[j]==0){
          superString +=" "+blocked;  
        }else{
          superString +=" "+cViernes[j];
        }
      }else{
        superString +=" "+cViernes[j];
      }
      superString +="|";
      WriteToClient(superString);
      if(bloqueP2==6){
        WriteToClient("----------Almuerzo---------");
      }
      bloqueP1 += 2;
      bloqueP2 = bloqueP1+1;
    }
    WriteToClient("");
  }
}